#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <vector>
#include <string>
using namespace std;

#define LICENSEKEY "XXXXXXXXXXXXXXXXXXXXXXX"

extern "C" __declspec(dllexport)
BOOL WINAPI VeryPDFEMF2Vector(HENHMETAFILE hEMF, const char *lpszOutFile);
extern "C" __declspec(dllexport)
void WINAPI VeryPDFSetLicenseCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
int WINAPI VeryPDFEMF2VectorCmd(LPCTSTR lpCommand);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

typedef BOOL (WINAPI *VeryPDFEMF2VectorFunc)(HENHMETAFILE hEMF, const char *lpszOutFile);
typedef void (__stdcall *VeryPDFSetLicenseCodeFunc)(const char *lpRegcode);
typedef int (WINAPI *VeryPDFEMF2VectorCmdFunc)(LPCTSTR lpCommand);
VeryPDFEMF2VectorFunc lpVeryPDFEMF2Vector = NULL;
VeryPDFSetLicenseCodeFunc lpVeryPDFSetLicenseCode = NULL;
VeryPDFEMF2VectorCmdFunc lpVeryPDFEMF2VectorCmd = NULL;

BOOL ConvertEMF2VectorDynamic(char *lpEMFFile, const char *lpOutFile)
{
	HENHMETAFILE hEMF = GetEnhMetaFile(lpEMFFile);
	if(hEMF == NULL)
		return FALSE;
	char path[_MAX_PATH];
	GetModulePath(path,"emf2vecsdk.dll");
	HINSTANCE hEMF2Vector = LoadLibrary(path);
	if(hEMF2Vector == NULL)
		return FALSE;
	lpVeryPDFEMF2Vector=(VeryPDFEMF2VectorFunc)GetProcAddress(hEMF2Vector,"VeryPDFEMF2Vector");
	if(lpVeryPDFEMF2Vector==NULL)
		return FALSE;
	lpVeryPDFSetLicenseCode=(VeryPDFSetLicenseCodeFunc)GetProcAddress(hEMF2Vector,"VeryPDFSetLicenseCode");
	if(lpVeryPDFSetLicenseCode==NULL)
		return FALSE;
	lpVeryPDFEMF2VectorCmd=(VeryPDFEMF2VectorCmdFunc)GetProcAddress(hEMF2Vector,"VeryPDFEMF2VectorCmd");
	if(lpVeryPDFEMF2VectorCmd==NULL)
		return FALSE;
	lpVeryPDFSetLicenseCode(LICENSEKEY);
	BOOL bResult = lpVeryPDFEMF2Vector(hEMF,lpOutFile);
	FreeLibrary(hEMF2Vector);
	DeleteEnhMetaFile(hEMF);
	return bResult;
}
void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		printf("\"%s\" D:\\test.emf\n", argv[0]);
		return;
	}
	VeryPDFSetLicenseCode(LICENSEKEY);
	int nRet = 0;
	char szEMFFile[MAX_PATH];
	strcpy(szEMFFile, argv[1]);
	if(strstr(szEMFFile, "*"))
	{
		char szCommandLine[2048] = {0};
		sprintf(szCommandLine, "emf2vec -append 2 \"%s\" \"%s\"", szEMFFile, "C:\\out.pdf");
		nRet = VeryPDFEMF2VectorCmd(szCommandLine);
	}
	else
	{
		char szPDFFile[MAX_PATH];
		strcpy(szPDFFile, szEMFFile);
		strcat(szPDFFile, ".pdf");
		
		char szEPSFile[MAX_PATH];
		strcpy(szEPSFile, szEMFFile);
		strcat(szEPSFile, ".eps");

		char szPSFile[MAX_PATH];
		strcpy(szPSFile, szEMFFile);
		strcat(szPSFile, ".ps");
		
		char szSVGFile[MAX_PATH];
		strcpy(szSVGFile, szEMFFile);
		strcat(szSVGFile, ".svg");

		HENHMETAFILE hEMF = GetEnhMetaFile(szEMFFile);
		if(hEMF == NULL)
			return;
		nRet = VeryPDFEMF2Vector(hEMF, szPSFile);
		nRet = VeryPDFEMF2Vector(hEMF, szEPSFile);
		nRet = VeryPDFEMF2Vector(hEMF, szPDFFile);
		nRet = VeryPDFEMF2Vector(hEMF, szSVGFile);
	}

//	ConvertEMF2VectorDynamic(szEMFFile, szEPSFile);
//	ConvertEMF2VectorDynamic(szEMFFile, szPDFFile);
}